(function ($) {
    var isAutoplay = true;         // 自动播放
    var playAll = false;           // 顺序播放
    var playingAudio = null;       // 正在播放
    var answerCallback = null;     // 答案回调
    var touchEvent = null;         // 触摸事件
    var bodyClick = null;          // body发生点击
    var templateType = null;       // 当前渲染模板类型
    var audioTemplateAudio = null; // 听力模板播放音频
    var playModel = null;          // 听力模板播放模式
    var playSpeed = 1;             // 听力模板播放倍速
    var openOutUrl = null;         // 打开外部链接
    var awsAudiosWaitPlay = [];    // 云语音待播放列表
    var audioOverCallback = null;  // 音频播放完成回调（无音频算作播放完成）
    var linkGameAnswers = null;          // 连连看正确答案 object
    var linkGameAnswerOver = null;       // 连连看答题结束

    $(function () {
        // 点击图片放大
        $(document.body).on("click", ".image", function (e) {
            if (window.viewImage) {
                window.viewImage(e.target.src, e.target.title);
            }
        });

        // 点击开始播放
        $(document.body).on("click", ".audio", function () {
            var audio = $(this).find("audio")[0];
            if (audio) {
                toggleAudioPlay(audio);
            }
        });

        // 选择题回调父级
        $(document.body).on("click", "input[name=option]", function (e) {
            if (answerCallback) {
                var options = [];
                $("input[name=option]").each((index, ele) => {
                    if ($(ele).is(":checked")) {
                        options.push(ele.value);
                        $(ele).parent(".choice-option").addClass("select");
                    } else {
                        $(ele).parents(".choice-option").removeClass("select");
                    }
                });
                answerCallback(options);
            }
        });

        // 点击a标签
        $(document.body).on("click", "a", function (e) {
            e.preventDefault();
            if ($(this).prop('href') && openOutUrl) {
                openOutUrl($(this).prop('href'));
            }
        });

        // 隐藏区域点击显示
        $(document.body).on("click", ".hidden.click-show", function (e) {
            $(this).removeClass('hidden');
        });

        // tab切换
        $(document.body).on("click", ".tabs .tab", function (e) {
            $(this).addClass('active').siblings().removeClass('active');
            $('.sub-content.' + $(this).prop('title')).addClass('show').siblings('.sub-content').removeClass('show');
        });

        // 判断题点击回调父级
        $(document.body).on("click", ".judgement-option", function (e) {
            if ($(e.target).hasClass("select")) {
                $(e.target).removeClass("select");
            } else {
                $(e.target).addClass("select").siblings().removeClass("select");
            }
            if (answerCallback) {
                var options = [];
                $(".judgement-option").each((index, ele) => {
                    if ($(ele).hasClass("select")) {
                        options.push(ele.innerHTML)
                    }
                });
                answerCallback(options);
            }
        });

        // 组词成句点击回调
        $(document.body).on("click", ".select-item", function (e) {
            if ($(this).hasClass('disabled')) {
                return false;
            }

            // 组词成句
            if ($(".question-warp").length) {
                if ($(this).hasClass('top')) {
                    $(".answer-warp .select-item.disabled[title=" + $(this).prop("title") + "]").eq(0).removeClass("disabled");

                    $(this).remove();
                } else {
                    var cloneNode = $(this).clone().addClass('top');
                    $(".question-warp").append(cloneNode);

                    $(this).addClass("disabled");
                }

                // 选词填空
            } else {
                if ($(this).hasClass('top')) {
                    var data = $(this).prop("title");
                    if (data) {
                        $(".answer-warp .select-item.disabled[title=" + data + "]").eq(0).removeClass("disabled");

                        $(this).removeClass('top').removeClass('show').html('占位字符').prop('title', '');
                    }
                } else {
                    if ($(".top-box .select-item").not('.show').length) {
                        var data = $(this).prop('title');
                        $(".top-box .select-item").not('.show').eq(0).html(data).prop('title', data).addClass('top').addClass('show');

                        $(this).addClass("disabled");
                    }
                }
            }

            if (answerCallback) {
                var options = [];
                $(".top-box .select-item").each((index, ele) => {
                    options.push($(ele).prop("title"))
                });
                answerCallback(options);
            }
        });

        // 完型填空点击展示答案
        $(document.body).on("click", ".cloze-blank", function () {
            if ($(this).hasClass('click-show')) {
                $(this).addClass('cloze-item').removeClass('cloze-blank').removeClass('click-show');
            }
        });

        // 点击body回调
        $(document.body).on("click", function(e) {
            if (bodyClick) {
                // 点击音频不进行翻转
                if (isBodyClick(e.target)) {
                    var className = e.target.className || '';
                    bodyClick(className);
                }
            } else {
                // 完型填空点击正面依次展示全部答案
                var $clozes = $('.cloze-blank');
                if ($clozes.length && isBodyClick(e.target)) {
                    var index = 0;
                    var timer = null;
                    var showItem = function () {
                        var element = $clozes[index];
                        if (element) {
                            if ($(element).hasClass('cloze-item')) {
                                index++;
                                showItem();
                            } else {
                                if ($(element).hasClass('click-show')) {
                                    $(element).addClass('cloze-item').removeClass('cloze-blank').removeClass('click-show');
                                    index++;
                                    timer = setTimeout(showItem, 1000);
                                } else {
                                    index++;
                                    showItem();
                                }
                            }
                        } else {
                            clearTimeout(timer);
                        }
                    }
                    showItem();
                }
            }
        });

        //滑动处理
        var startX, startY, moveEndX, moveEndY, X, Y, time;
        $(document.body).on('touchstart', function(e) {
            if (touchEvent) {
                startX = e.touches[0].pageX;
                startY = e.touches[0].pageY;
                time = new Date().getTime();
            }
        });
        $(document.body).on('touchend', function (e) {
            if (touchEvent) {
                var timeNow = new Date().getTime();
                moveEndX = e.changedTouches[0].pageX;
                moveEndY = e.changedTouches[0].pageY;

                X = moveEndX - startX;
                Y = moveEndY - startY;
                touchTime = timeNow - time;

                if (touchTime > 2000) {
                    return false;
                }
                var derection = '';
                if (X > 80 && Math.abs(X) > Math.abs(Y)) {
                    derection = 'right';
                } else if (X < -80 && Math.abs(X) > Math.abs(Y)) {
                    derection = 'left';
                }
                if (derection) {
                    touchEvent(derection);
                }
            }
        });

        // 连连看交互逻辑
        var answersAll = [];
        var answersNow = [];
        var selectClass = 'select';
        var correctClass = 'correct';
        var errorClass = 'error';
        $(document.body).on('click', '.option-content .option-item', function () {
            if ($(this).hasClass(correctClass) || $(this).hasClass(errorClass)) {
                return;
            }
            if ($(this).hasClass(selectClass)) {
                $(this).removeClass(selectClass);
                answersNow = [];
                return;
            }

            // 还原标签内容
            var itemData = $(this).html();
            itemData = filterAudio(itemData);
            itemData = filterImage(itemData);
            itemData = htmlDecode(itemData);

            if (answersNow.length === 0) {
                $(this).addClass(selectClass);
                answersNow.push(itemData);
                return;
            }

            if (answersNow.length === 1) {
                const correctAnswer = linkGameAnswers[itemData];
                if (correctAnswer === answersNow[0]) {
                    $(this).addClass(selectClass);
                    $('.option-content .option-item.' + selectClass).removeClass(selectClass).addClass(correctClass);
                    answersNow.push(itemData);
                    answersAll.push(answersNow);
                    answersNow = [];

                    // 判断是否答完
                    if (answersAll.length * 2 === $('.option-content .option-item').length) {
                        answersAll = [];
                        if (linkGameAnswerOver) {
                            linkGameAnswerOver();
                        }
                    }
                } else {
                    $(this).addClass(errorClass);
                    $('.option-content .option-item.' + selectClass).removeClass(selectClass).addClass(errorClass);
                    answersNow = [];
                    setTimeout(() => {
                        $('.option-content .option-item.' + errorClass).removeClass(errorClass);
                    }, 1500);
                }
                return;
            }
        });
    });

    // 设置笔记
    window.setNote = function (note) {
        note = htmlEncode(note || '');
        note = note.replace(/\n/g, '<br>');
        $('.sub-content.note').html(note);
    }

    // 初始化页面内容 设置暗黑模式
    window.setDarkMode = function (isDark) {
        if(isDark) {
            $('body').addClass('dark');
        }
    }
  
    // 设置body的class
    window.setBodyBackground = function (className) {
        document.body.className = className;
    }

    // 设置根元素字体大小
    window.setHtmlFontSize = function (fonsize) {
        $('html').css('font-size', fonsize + 'px');
    }

    // 设置音频播放完成
    window.setAudioOverCallback = function (callback) {
        audioOverCallback = callback;
    }

    // 设置答案回调
    window.setAnswerCallback = function (callback) {
        answerCallback = callback;
    }

    // 设置打开外部链接回调
    window.setOpenOutUrlCallback = function (callback) {
        openOutUrl = callback;
    }

    // 开关自动播放
    window.setAutoplay = function (autoplay) {
        isAutoplay = autoplay;
    }

    // 设置触摸回调
    window.setTouchEvent = function (eventFn) {
        touchEvent = eventFn;
    }

    // 设置Body点击回调
    window.setBodyClickEvent = function (eventFn) {
        bodyClick = eventFn;
    }

    // 开始播放语音
    window.startAudioPlay = function () {
        playAllAudio();
    }

    // 关闭播放语音
    window.stopAudioPlay = function () {
        closeAllAudio();
    }

    // 模板类型
    window.setTemplateType = function (type) {
        templateType = type;
    }

    // 设置云语音loading
    window.setAwsLoading = function (fieldName) {
        function posTop(elem) {
            var y = elem.offsetTop;
            while (elem = elem.offsetParent) {
                y += elem.offsetTop;
            }
            return y;
        }
        var elementItem = $('.field-' + fieldName)[0];
        if (elementItem) {
            var top = posTop(elementItem);
            var $loadingEle = $(`
                <div class="audio aws-audio audio-${fieldName}-warp" style="top: ${top}px;">
                    <img class="icon loading" src="/assets/card-view/icon-loading.png" />
                </div>
            `);
            $('#body').append($loadingEle);
        }
    }

    // 清除云语音loading
    window.removeAwsLoading = function (fieldName) {
        $(`.aws-audio.audio-${fieldName}-warp`).remove();
    }

    // 设置云语音
    window.setAwsAudio = function (fieldName, audioUrl) {
        playAll = true;
        var warpElement = $(`.audio-${fieldName}-warp`)[0];
        if (warpElement) {
            $(warpElement).html(`
                <img class="icon" src="/assets/card-view/audio.png" />
                <audio class="audio-${fieldName}" src="${audioUrl}" controls="controls" preload="auto"></audio>
            `);

            awsAudiosWaitPlay.push($(warpElement).find('audio')[0]);
            if (!playingAudio && isAutoplay) {
                awsAutoPlay();
            }
        }
    }

    // 设置云语音错误
    window.setAwsAudioError = function (fieldName) {
        playAll = true;
        var warpElement = $(`.audio-${fieldName}-warp`)[0];
        if (warpElement) {
            $(warpElement).html(`
                <img class="icon" src="/assets/card-view/audio.png" />
                <audio class="audio-${fieldName}" src="/assets/card-view/speaking-language-wrong.mp3" controls="controls" preload="auto"></audio>
            `);

            awsAudiosWaitPlay.push($(warpElement).find('audio')[0]);
            if (!playingAudio && isAutoplay) {
                awsAutoPlay();
            }
        }
    }

    // 清除云语音
    window.clearAwsAudios = function () {
        closeAllAudio();
        playingAudio = null;
        playAll = false;
        $('.aws-audio').remove();
        awsAudiosWaitPlay = [];
    }

    // 设置听力模板播放模式
    window.setPlayModel = function (model) {
        playModel = model;
    }

    // 设置听力模板播放模式
    window.setPlaySpeed = function (speed) {
        playSpeed = speed;
        if (audioTemplateAudio) {
            audioTemplateAudio.playbackRate = speed;
        }
    }

    // 设置连连看答案 answers -> [['name', '名字'], ['height', '高度']]
    window.setLinkGameAnswer = function (answers, answerOver) {
        linkGameAnswers = {};
        answers.forEach(element => {
            element[0] = htmlDecode(element[0]);
            element[1] = htmlDecode(element[1]);
            linkGameAnswers[element[0]] = element[1];
            linkGameAnswers[element[1]] = element[0];
        });
        linkGameAnswerOver = answerOver;
    }

    // 初始化页面内容及样式
    window.show = function (contentHtml, css) {
        // 设置显示内容
        $content = $('#body').html(contentHtml);
        // 将document的滚动位置手动置为0，兼容ios13下iframe滚动bug
        $(document).scrollTop(0);
        // 设置样式
        if (css) {
            $("style").html(css);
        }
        // 重构 audio 样式
        $content.find("audio").wrap('<div class="audio"></div>').parent().append('<img class="icon" src="/assets/card-view/audio.png" />');

        // 听力模板
        if (templateType === 4) {
            initAudioTemplatePlay();    // 初始化听力模板事件
        } 

        if (isAutoplay) {
            playAllAudio();
        }

        // 图片加载失败
        $(".image, .audio-element").on('error', function () {
            var onlineUrl = $(this).data('onlineurl');
            if (onlineUrl) {
                $(this).attr('src', onlineUrl);
            } else {
                var resourceName = $(this).data('name');
                $(this).attr('alt', '无效资源：' + resourceName);
            }
        });
    }

    // 隐藏元素
    window.hideSelectors = function (selectors) {
        if (selectors && selectors.length) {
            selectors.forEach(function (s) {
                $(s).hide();
            });
        }
    }

    // 初始化听力模板事件
    function initAudioTemplatePlay() {
        var totleTime = null;
        var timer = null;
        audioTemplateAudio = $(document.body).find('audio')[0];
        if (!audioTemplateAudio) {
            callbackAudioOver();
            return false
        };
        // 设置默认倍速
        audioTemplateAudio.playbackRate = playSpeed;

        $(audioTemplateAudio).off("canplay").on('canplay', function () {
            // 初始化音频时长
            totleTime = audioTemplateAudio.duration;
            // 自动开始播放
            if (isAutoplay) {
                audioTemplateAudio.play();
            }
        });
        $(audioTemplateAudio).off("play").on('play', function () {
            timer = setInterval(() => {
                if (!audioTemplateAudio) {
                    clearInterval(timer);
                    timer = null;
                    return false;
                }

                var currentTime = audioTemplateAudio.currentTime;
                var progress = Math.ceil(currentTime / totleTime * 100);
                $('.progress-bar').css('width', progress + '%');
                $('.play-time').html(formartTime(currentTime));
            }, 1000);
            updatePlayBtnView();
        });
        $(audioTemplateAudio).off("pause error").on('pause error', function () {
            clearInterval(timer);
            timer = null;
            updatePlayBtnView();
            callbackAudioOver();
        });
        $(audioTemplateAudio).off("ended").on('ended', function () {
            if (playModel === 'circulation') {
                audioTemplateAudio.play();
            } else {
                clearInterval(timer);
                timer = null;
            }
            updatePlayBtnView();
            callbackAudioOver();
        });

        // 点击开始播放
        $(document.body).off("click", '.play-btn').on("click", ".play-btn", function () {
            if (audioTemplateAudio) {
                if (audioTemplateAudio.paused) {
                    audioTemplateAudio.play();
                } else {
                    audioTemplateAudio.pause();
                }
            }
        });
        // 点击空白开始播放
        $(document.body).off("click", '.bottom-container.front').on("click", ".bottom-container.front", function () {
            if (audioTemplateAudio) {
                audioTemplateAudio.play();
            }
        })
    }

    // 格式化时间
    function formartTime(time) {
        var m = Math.floor(time / 60);
        if (m < 10) {
            m = '0' + m;
        }
        var s = Math.ceil(time % 60);
        if (s < 10) {
            s = '0' + s;
        }
        return m + ':' + s;
    }

    // 更新播放按钮样式
    function updatePlayBtnView() {
        if (audioTemplateAudio.paused) {
            $('.play-btn').removeClass('playing');
            playingAudio = null;
        } else {
            $('.play-btn').addClass('playing');
            playingAudio = audioTemplateAudio;
        }
    }

    // 是否是点击body
    function isBodyClick(target) {
        var className = target.className || '';
        var tagName = target.tagName;

        return className.indexOf('audio') < 0 &&
        className.indexOf('icon') < 0 &&
        className.indexOf('cloze-blank') < 0 &&
        className.indexOf('cloze-item') < 0 &&
        className.indexOf('play-btn') < 0 &&
        className.indexOf('image') < 0 &&
        className.indexOf('bottom-container front') < 0 &&
        className.indexOf('tab') < 0 &&
        className.indexOf('option-item') < 0 &&
        tagName !== 'A';
    }

    // 自动播放
    function playAllAudio() {
        var audios = $(document.body).find("audio");
        if (audios.length == 0) {
            callbackAudioOver();
            return;
        }
        function playNext(index) {
            var audio = audios[index];
            if (audio) {
                // 去除云语音重复播放
                var awsIndex = awsAudiosWaitPlay.findIndex(function(a) {
                    return a === audio;
                });
                if (awsIndex >= 0) {
                    awsAudiosWaitPlay.splice(awsIndex, 1);
                }
                playAudio(audio, function () {
                    if (playAll) { // 继续播放？
                        playNext(++index);
                    }
                });
            } else { // 播完了
                playAll = false;
                awsAutoPlay();
            }
        }
        playAll = true; // 顺序播放模式
        playNext(0);
    }

    // 通知音频播放结束
    function callbackAudioOver() {
        if (!audioOverCallback) {
            return false;
        }
        audioOverCallback();
    }

    // 云语音自动播放
    function awsAutoPlay() {
        if (!awsAudiosWaitPlay.length) {
            callbackAudioOver();
            return;
        }
        function playNext() {
            var audio = awsAudiosWaitPlay[0];
            if (audio) {
                playAudio(audio, function () {
                    if (playAll) { // 继续播放？
                        awsAudiosWaitPlay = awsAudiosWaitPlay.slice(1);
                        playNext();
                    }
                });
            } else { // 播完了
                playAll = false;
                callbackAudioOver();
            }
        }
        playAll = true; // 顺序播放模式
        playNext();
    }

    // 关闭所有音频播放
    function closeAllAudio() {
        playAll = false; // 终止顺序播放
        awsAudiosWaitPlay = [];   // 清空待播放云语音
        if (playingAudio) { // 关闭正在播放的音频
            playingAudio.pause();
            updateAudioPlayingView(playingAudio);
        }
    }

    // 开始/结束播放
    function toggleAudioPlay(audio) {
        if (audio.paused) {
            playAll = false; // 终止顺序播放
            if (playingAudio) { // 关闭正在播放的音频
                playingAudio.pause();
                updateAudioPlayingView(playingAudio);
            }
            playAudio(audio);
        } else { // playing
            audio.pause();
            updateAudioPlayingView(audio);
        }
    }

    // 开始播放
    function playAudio(audio, endedFn) {
        if (playingAudio) {
            playingAudio.pause();
            updateAudioPlayingView(playingAudio);
        }
        $(audio).one("ended error", function () {
            updateAudioPlayingView(audio);
            if (playingAudio == audio) {
                playingAudio = null;
            }
            if (endedFn) { // 结束回调
                endedFn(audio);
            }
        });
        playingAudio = audio;
        audio.play();
        updateAudioPlayingView(audio);
    }

    // 更新播放样式
    function updateAudioPlayingView(audio) {
        var isPlaying = !audio.paused;
        var $audioWrapper = $(audio).closest(".audio");
        if (isPlaying) {
            $audioWrapper.addClass("playing");
            $audioWrapper.find(".icon").prop("src", "/assets/card-view/audio-playing.gif");
        } else {
            $audioWrapper.removeClass("playing");
            $audioWrapper.find(".icon").prop("src", "/assets/card-view/audio.png");
        }
    }

    /**
     * 过滤音频
     */
    function filterAudio(str) {
        var regAudio = /<audio.*?(?:>|\/>)<\/audio>/gi;
        var regName = /\<audio .*data-name=[\"|\'](.*?)[\"|\']\s*.*\/*\><\/audio>/;
        var audioArr = str.match(regAudio);
        if (audioArr) {
            audioArr.forEach((audio) => {
                if (audio.match(regName)) {
                    str = str.replace(audio, `[audio:${audio.match(regName)[1]}]`);
                } else {
                    str = str.replace(audio, '');
                }
            });
        }
        return str;
    }

    /**
     * 过滤图片
     */
    function filterImage(str) {
        var regImage = /<img.*?(?:>|\/>)/gi;
        var regName = /\<img .*data-name=[\"|\'](.*?)[\"|\']\s*.*\/*\>/;
        var imgArr = str.match(regImage);
        if (imgArr) {
            imgArr.forEach((img) => {
                if (img.match(regName)) {
                    str = str.replace(img, `[image:${img.match(regName)[1]}]`);
                } else {
                    str = str.replace(img, '');
                }
            });
        }
        return str;
    }

    /**
     * html转义
     */
    function htmlDecode(html) {
        var div = document.createElement('div');
        div.innerHTML = html;
        return div.innerText;
    }

    /**
     * html转义
     */
    function htmlEncode(html) {
        var div = document.createElement('div');
        div.innerText = html;
        return div.innerHTML;
    }
})(jQuery);
